
#ifndef IMAGE_H
#define IMAGE_H

#include <cassert>
//extern "C" {
#include "gd.h"
//}

using namespace std;

class Image
{
protected:
        int _dx;
	int _dy;
	int* _data;
public:

	Image(): _dx(0), _dy(0), _data(0) {};
	Image(int size_x, int size_y) : _dx(size_x), _dy(size_y) 
	{
		_data = (int*) new int[size_x * size_y];
		assert (_data != 0);
	};
	Image (gdImagePtr im) : _dx(gdImageSX(im)), _dy(gdImageSY(im))
	{
		_data = (int*) new int[gdImageSX(im) * gdImageSY(im)];
                assert (_data != 0);
		for (int y = 0; y < _dy; y++)
			for (int x = 0; x < _dx; x++)
				_data[y * _dx + x] = gdImageGetPixel(im, x, y);
	};
	Image (Image& im): _dx(im.dx()), _dy(im.dy())
	{
               _data = (int*) new int[im.dx() * im.dy()];
                assert (_data != 0);

		int size = _dx * _dy;
		for (int i = 0; i < size; i++)
			_data[i] = im[i]; 
	};
//      virtual ostream& Put(ostream& s) const{ _dx.Put(s); _dy.Put(s); _data.Put(s); return s;};
	
	int dx() {return _dx;};
	int dy() {return _dy;};
	int* data() {return _data;}; 
	int& operator[] (const int i) { return _data[i];};
	void setSize (int size_x, int size_y){
		_dx = size_x;
		_dy = size_y;
		delete[] _data;
		_data = (int*) new int[size_x * size_y];
                assert (_data != 0);
	}
	void set (int x, int y, int val) {
		assert ((x < _dx) && (y < _dy));
		_data [y * _dx + x] = val;
	}
	int get (int x, int y) {
		assert ((x < _dx) && (y < _dy));
		return _data[y * _dx + x];
	}
};

#endif


